<?
// ********** settings ********************************************************

$allowed_to_kill = array('127.0.0.1', '192.168.16.124', '217.10.34.24');    // hosts that are allowed to kill processes
$go_exe = 'D:\OS2Apps\go.exe';                                              // path to go.exe
$zuko_uptime = 'D:\OS2Apps\uptime.exe';                                     // uptime.exe by zuko - http://zuko.mitm.ru/
$zuko_mem = 'D:\OS2Apps\mem.exe';                                           // mem.exe by zuko
$ths_getram = 'D:\OS2Apps\Theseus\getram.exe';                              // Theseus4 getram utility
$pstat = 'C:\OS2\PSTAT.EXE';                                                // PSTAT utility location
$psfiles = 'C:\OS2\PSFILES.EXE';                                            // PSFILES utility location
$expose_zuko = true;                                                        // zuko rocks
$show_getram = true;                                                        // show getram output
$parse_pstat = true;                                                        // parse PSTAT output
$parse_psfiles = true;                                                      // parse PSFILES output

// ********** global vars *****************************************************

$proc = array();
$mem = array();

preg_match('/(^[^?]+)(\?|$)/', $_SERVER['REQUEST_URI'], $m);       // CGI workaround
$self = $m[1];

// DosOpen modes
$modes1 = array(
    0x8000 => 'OPEN_FLAGS_DASD',
    0x4000 => 'OPEN_FLAGS_WRITE_THROUGH',
    0x2000 => 'OPEN_FLAGS_FAIL_ON_ERROR',
    0x1000 => 'OPEN_FLAGS_NO_CACHE',
);
$modes_10_8 = array(
    0x0300 => 'OPEN_FLAGS_RANDOMSEQUENTIAL',
    0x0200 => 'OPEN_FLAGS_RANDOM',
    0x0100 => 'OPEN_FLAGS_SEQUENTIAL',
    0x0000 => 'OPEN_FLAGS_NO_LOCALITY',
);
$mask_10_8 = 0x0700;    // 0000'0111'0000'0000
$modes2 = array(
    0x0080 => 'OPEN_FLAGS_NOINHERIT',
    0x0040 => 'OPEN_SHARE_DENYNONE',
    0x0030 => 'OPEN_SHARE_DENYREAD',
    0x0020 => 'OPEN_SHARE_DENYWRITE',
    0x0010 => 'OPEN_SHARE_DENYREADWRITE',
);
$modes_2_0 = array(
    0x0002 => 'OPEN_ACCESS_READWRITE',
    0x0001 => 'OPEN_ACCESS_WRITEONLY',
    0x0000 => 'OPEN_ACCESS_READONLY',
);
$mask_2_0 = 0x0003;     // 0000'0000'0000'0011

// file attributes
$attrs = array(
    0x0020 => 'FILE_ARCHIVED',
    0x0010 => 'FILE_DIRECTORY',
    0x0004 => 'FILE_SYSTEM',
    0x0002 => 'FILE_HIDDEN',
    0x0001 => 'FILE_READONLY',
//  0x0000 => 'FILE_NORMAL'
);

// priorities
$priorities = array(1 => 'idle', 'regular', 'server', 'timecritical');

// ********** HTML blocks *****************************************************

$header = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Process viewer</title>
%s
<body>
';

$styles = '<style type="text/css">
<!--
body {font-family: monospace; background-color: #000000; color: #808080; margin: 1em 1em 1em 1em; font-weight: bold; font-size: 0.8 em}
tr {text-align: right; color: #808080}
tr:hover {background-color: #004040;}
.tr1, .tr1:hover {background-color: #000000}
.tr2 {text-align: left; color: #808080}
.tr2:hover {background-color: #004040}
.tr3, .tr3:hover {background-color: #000000; text-align: left; color: #808080}
td {font-family: monospace; font-weight: bold; font-size: 0.8 em}
th {font-family: monospace; font-weight: bold; font-size: 0.8 em}
a {text-decoration: none; color: #B0B0B0}
a:hover, a:active {text-decoration: none; color: #FFFF80}
.a1 {text-decoration: none; color: #808080}
.a1:hover, .a1:active {text-decoration: none; color: #000000; background-color: #00FF00}
.a2 {text-decoration: none; color: #808080}
.a2:hover, .a2:active {text-decoration: none; color: #000000; background-color: #FF0000}
.span1 {border-bottom: thin solid #808080}
.bleft {border-left: thin solid #808080}
-->
</style>';

$footer = '</body>
</html>
';

$table_spacer = '<tr class="tr1"><th>====&nbsp;</th><th>====&nbsp;</th><th colspan=2>=======&nbsp;</th><th>===&nbsp;</th><th>====&nbsp;</th>%s<th>============&nbsp;</th><th align="left">============</th></tr>'."\n";

if ($show_getram) {
    $table_spacer = sprintf($table_spacer, '<th>========&nbsp;</th><th>=======&nbsp;</th>');
} else {
    $table_spacer = sprintf($table_spacer, '');
}

$table_header = "<br><br>\n".
'<table border=0 cellpadding=0 cellspacing=0>'.
'<tr class="tr1">'.
'<th><a href="'.$self.'?sort=PID" title="Sort by PID">PID&nbsp;</a></th>'.
'<th><a href="'.$self.'?sort=PPID" title="Sort by PPID">PPID&nbsp;</a></th>'.
'<th colspan=2><a href="'.$self.'?sort=Sess" title="Sort by session">Sess&nbsp;&nbsp;</a></th>'.
'<th><a href="'.$self.'?sort=Thr" title="Sort by thread">Thr&nbsp;</a></th>'.
'<th><a href="'.$self.'?sort=Prio" title="Sort by priority">Prio&nbsp;</a></th>'.
'%s'.
'<th><a href="'.$self.'?sort=CPU" title="Sort by CPU time">CPU time&nbsp;&nbsp;</a></th>'.
'<th align="left"><a href="'.$self.'?sort=Name" title="Sort by name">Name</a></th></tr>'.
"\n".$table_spacer;

if ($show_getram) {
    $table_header = sprintf($table_header, '<th><a href="'.$self.'?sort=PrivMem" title="Sort by private memory">Private&nbsp;</a></th><th><a href="'.$self.'?sort=ShMem" title="Sort by shared memory">Shared&nbsp;</a></th>');
} else {
    $table_header = sprintf($table_header, '');
}

$table_footer = $table_spacer."</table>\n";

$back = "\n<br><a href=\"$self\">&lt;&lt; back</a>\n";
$zuko = '<a href="http://zuko.mitm.ru/" title="http://zuko.mitm.ru/">zuko</a>';
$theseus4 = '<a href="ftp://service.boulder.ibm.com/ps/products/os2/fixes/v4.5warp/theseus4/" title="ftp://service.boulder.ibm.com/ps/products/os2/fixes/v4.5warp/theseus4/">theseus4</a>';

// ========== start ===========================================================

if ((strpos($_SERVER['HTTP_USER_AGENT'], 'Mozilla/4') !== false) and !strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE')) {
    $header = sprintf($header, '');     // do not show styles to Netscape
} else {
    $header = sprintf($header, $styles);
}

// ********** if request to kill **********************************************

$k = intval($_GET['k']);
$ka = $_GET['ka'];

if ($k or strlen($ka)) {
    if ($_GET['sure'] == 'y') {
        if (!in_array($_SERVER['REMOTE_ADDR'], $allowed_to_kill)) {
            echo $header;
            echo "Go kill yourself, bro!\n<br>You are not allowed to kill processes on this box.";
            echo $back;
            echo $footer;
            die();
        }
        $cmd = '';
        if ($k) { $cmd = "$go_exe -k $k"; }
        if (strlen($ka)) { $cmd = "$go_exe -ka $ka"; }
        if (strlen($cmd)) { exec($cmd); }
        my_redirect($self);
        die();
    }
    echo $header;
    $go = `$go_exe`;
    parse_go_procs($go, $proc);
    if ($k) {
        $name = '';
        foreach ($proc as $a) {
            if (intval($a['pid']) == $k) {
                $name = trim($a['name']);
                break;
            }
        }
        if (strlen($name)) {
            echo "Are you sure you want to kill process with PID $k ($name)?\n";
            echo '<br><a href="'.$self.'?k='.$k.'&sure=y" class="a1">&nbsp;&nbsp;&nbsp;yes&nbsp;&nbsp;&nbsp;</a>'."\n";
            echo '<a href='.$self.' class="a2">&nbsp;&nbsp;&nbsp;no&nbsp;&nbsp;&nbsp;</a>'."\n";
        } else {
            echo "Process with PID $k not found!";
            echo $back;
        }
    } else {
        $count= 0;
        foreach ($proc as $a) {
            if (trim($a['name']) == $ka) { $count++; }
        }
        if ($count) {
            echo "Are you sure you want to kill all $ka processes (total: $count)?\n";
            echo '<br><a href="'.$self.'?ka='.$ka.'&sure=y" class="a1">&nbsp;&nbsp;&nbsp;yes&nbsp;&nbsp;&nbsp;</a>'."\n";
            echo '<a href='.$self.' class="a2">&nbsp;&nbsp;&nbsp;no&nbsp;&nbsp;&nbsp;</a>'."\n";
        } else {
            echo "No $ka process(es) found!";
            echo $back;
        }
    }
    echo $footer;
    die();
}

// ********** if show more... *************************************************

if ($pid = intval($_GET['show'])) {
    echo $header;
    $cmd = sprintf('%s /P:%X', $pstat, $pid);
    echo "<span class=\"span1\">PSTAT information:</span>\n";
    $out = `$cmd`;
    if ($parse_pstat) {
        echo "<br>\n".parse_pstat_output($out);
    } else {
        echo "<pre>\n$out</pre>";
    }
    echo "\n<br><hr size=1><br>";
    $cmd = sprintf('%s %X', $psfiles, $pid);
    echo "\n<a name=\"psfiles\"></a><span class=\"span1\">PSFILES information:</span>\n";
    $out = `$cmd`;
    if ($parse_psfiles) {
        echo "<br><br>\n".parse_psfiles_output($out);
    } else {
	    echo "<pre>\n$out</pre>";
    }
    echo $back;
    echo $footer;
    die();
}

// ********** if show `go` output *********************************************

$sort = $_GET['sort'];
$sortby = array('PID' => 'sort_by_pid', 'PPID' => 'sort_by_ppid', 'Sess' => 'sort_by_sess',
                'Thr' => 'sort_by_thr', 'Prio' => 'sort_by_prio', 'PrivMem' => 'sort_by_privmem',
                'ShMem' => 'sort_by_shmem', 'CPU' => 'sort_by_cpu', 'Name' => 'sort_by_name');

echo $header;

$go = `$go_exe`;
go_proc_report($go);
go_uptime_report($go);
if ($expose_zuko) { zuko_uptime_report($zuko_uptime); }

parse_go_procs($go, $proc);
if ($show_getram) { $ths_mem_report = parse_getram($ths_getram, $mem); }

$n = sizeof($proc);
if (strlen($sortby[$sort])) {
    usort($proc, $sortby[$sort]);
    if (($sort == 'CPU') or ($sort == 'Name')) {
        for ($i=0;$i<$n;$i++) { $proc[$i]['name'] = trim($proc[$i]['name']); }
    }
}

?><br><br>Process list<?
if (strlen($sortby[$sort])) {
    echo ' (sorted by '.$sort.') (<a href="'.$self.'">view unsorted</a>)';
}
?>:<?

echo $table_header;

$tmpl = '<tr>'.
'<td><a href="%s?k=%d" title="Kill process with PID %d">%d</a>&nbsp;</td>'.     // pid
'<td>%d&nbsp;</td>'.                                                            // ppid
'<td>%s&nbsp;</td>'.                                                            // sess1
'<td align="left">%s&nbsp;</td>'.                                               // sess2
'<td><a href="%s?ka=%s" title="Kill all %s">&nbsp;%s&nbsp;</a></td>'.           // thr
'<td title="%s">%s&nbsp;</td>'.                                                 // prio
'%s'.                                                                           // possible mem report
'<td>%s&nbsp;</td>'.                                                            // cpu
'<td align="left"><a href="%s?show=%d" title="Show more...">%s</a></td>'.       // name
'</tr>'."\n";
$tmpl2 = '<td>%s&nbsp;</td><td>%s&nbsp;</td>';                                  // priv mem, sh mem

for ($i=0;$i<$n;$i++) {
    $curr_pid = $proc[$i]['pid'];
    $out = sprintf($tmpl,
    $self, $curr_pid, $curr_pid, $curr_pid,
    $proc[$i]['ppid'],
    $proc[$i]['sess1'],
    $proc[$i]['sess2'],
    $self, urlencode(trim($proc[$i]['name'])), trim($proc[$i]['name']), $proc[$i]['thr'],
    say_prio($proc[$i]['prio']), $proc[$i]['prio'],
    '%s',
    $proc[$i]['cpu'],
    $self, $curr_pid, str_replace(' ', '&nbsp;', $proc[$i]['name']));
    if ($show_getram) {
        if (!strlen($privmem = $mem[$curr_pid]['privmem'])) { $privmem = '- - -'; }
        if (!strlen($shmem = $mem[$curr_pid]['shmem'])) { $shmem = '- - -'; }
        printf($out, sprintf($tmpl2, $privmem, $shmem));
    } else {
        printf($out, '');
    }
}

echo $table_footer;

if ($expose_zuko) { zuko_mem_report($zuko_mem); }
if ($show_getram) { echo $ths_mem_report; }

echo $footer;

// ========== end =============================================================


// ********** funcs *************************************************************

// show number of processes & threads from `go` output
function go_proc_report(&$go) {
    preg_match('/ (\d+) Processes with (\d+)/', $go, $m);
    list($match, $numproc, $numthr) = $m;
    echo "\nThere are $numproc processes with $numthr threads.\n";
}

// show uptime from `go` output
function go_uptime_report(&$go) {
    preg_match('/uptime is (\d+)d (\d+)h (\d+)m (\d+)s/', $go, $m);
    list($match, $day, $hour, $min, $sec) = $m;
    if (intval($day)) {
        printf("<br>System uptime is %d days %02d:%02d:%02d\n", $day, $hour, $min, $sec);
    } else {
        printf("<br>System uptime is %02d:%02d:%02d\n", $hour, $min, $sec);
    }
}

// parse `go.exe` output to $proc array
function parse_go_procs(&$go, &$proc) {
    preg_match_all('/(\d+)\s+(\d+)\s([0-9A-F]+) (\w+)\s+(\d+)\s+([0-9A-F]+)\s+([.:0-9]+)  (\s*[\S]+)/m', $go, $matches);
	// 0: match
	// 1: P-ID
	// 2: PPID
	// 3: Sess 1
	// 4: Sess 2
	// 5: Thr
	// 6: Prio
	// 7: CPU Time
	// 8: Name
    list($match, $pid, $ppid, $sess1, $sess2, $thr, $prio, $cpu, $name) = $matches;
    $n = sizeof($match);
    for ($i=0;$i<$n;$i++) {
        $proc[$i]['pid'] = intval($pid[$i]);
        $proc[$i]['ppid'] = intval($ppid[$i]);
        $proc[$i]['sess1'] = $sess1[$i];
        $proc[$i]['sess2'] = $sess2[$i];
        $proc[$i]['thr'] = $thr[$i];
        $proc[$i]['prio'] = $prio[$i];
        $proc[$i]['cpu'] = $cpu[$i];
        $proc[$i]['name'] = $name[$i];
        if (intval($pid[$i]) == 1) { $proc[$i]['name'] = 'SYSINIT'; }       // go.exe bug
    }
}

function parse_getram($ths_getram, &$mem) {
    GLOBAL $theseus4;
    $cmd = "$ths_getram 1 0";
    $ths = `$cmd`;
    preg_match_all('/^(\d+)\s+([.\d]+)M\s+([.\d]+)M\s+([.\d]+)\s+([.\d]+)\s+/m', $ths, $matches);
    // 0: match
    // 1: pid
    // 2: priv mem (Mb)
    // 3: sh mem (Mb)
    // 4: priv mem (pages)
    // 5: sh mem (pages)
    list($match, $pid, $privmem, $shmem, $privpages, $shpages) = $matches;
    $n = sizeof($pid);
    for ($i=0;$i<$n;$i++) {
        $key = intval($pid[$i]);
        $mem[$key] = array('privmem' => $privmem[$i], 'shmem' => $shmem[$i],
                           'privpages' => $privpages[$i], 'shpages' => $shpages[$i]);
    }
    // find summary
    preg_match_all('/^\s+([.\d]+)M\s+(|[.0-9]+M)\s+(\d+)\s+(|[.0-9]+)\s+(.*)/m', $ths, $matches);
//      251.355M   68.570M    64347    17554  Total RAM used
//      191.570M              49042           Free RAM available
//      --------            -------
//      511.496M             130943            Total RAM (Prvt+Shr+Free)
    list($match, $privmem, $shmem, $privpages, $shpages, $name) = $matches;
    $out = "<br>\n<table border=0 cellpadding=0 cellspacing=0>\n";
    $out .= '<tr class="tr1" valign="top"><th align="left">'.$theseus4.' memory report:</th><th colspan=2><span class="span1">Count in Megabytes</span>&nbsp;&nbsp;&nbsp;</th><th colspan=2><span class="span1">&nbsp;Count in Pages</span>&nbsp;</th></tr>'."\n";
    $out .= '<tr class="tr1"><th>&nbsp;</th><th>Private&nbsp;&nbsp;</th><th>Shared&nbsp;&nbsp;&nbsp;</th><th>Private&nbsp;&nbsp;</th><th>Shared&nbsp;</th></tr>'."\n";
    $n = sizeof($match);
    for ($i=0;$i<$n;$i++) {
        $pm = substr($privmem[$i], 0, -1).' Mb';
        if (strlen($sm = $shmem[$i])) { $sm = substr($sm, 0, -1).' Mb'; } else { $sm = '&nbsp;'; }
        $out .= sprintf("<tr><td>%s&nbsp;&nbsp;</td><td>%s&nbsp;&nbsp;</td><td>%s&nbsp;&nbsp;&nbsp;</td><td>%s&nbsp;&nbsp;</td><td>%s&nbsp;</td></tr>\n",
                        trim($name[$i]), $pm, $sm, $privpages[$i], $shpages[$i]);
    }
    $out .= "</table>\n";
    return $out;
}

// show zuko uptime report
function zuko_uptime_report($zuko_uptime) {
    GLOBAL $zuko;
    preg_match('/(\d+)d (\d+)h (\d+)m (\d+)s/', `$zuko_uptime`, $m);
    list($match, $day, $hour, $min, $sec) = $m;
    if (intval($day)) {
        printf("<br>$zuko says system uptime is %d days %02d:%02d:%02d\n", $day, $hour, $min, $sec);
    } else {
        printf("<br>$zuko says system uptime is %02d:%02d:%02d\n", $hour, $min, $sec);
    }
}

// show zuko mem report
function zuko_mem_report($zuko_mem) {
    GLOBAL $zuko;
    $out = "<br>$zuko memory report:\n<table border=0 cellpadding=0 cellspacing=0>\n";
    preg_match_all('/^(.+) :\s+([.\d]+) Mb\s+\((\d+)/m', `$zuko_mem`, $matches);
    // match
    // type of memory
    // Mb
    // kb
    list($match, $name, $mb, $kb) = $matches;
    $n = sizeof($match);
    for ($i=0;$i<$n;$i++) {
        $out .= sprintf("<tr><td>%s&nbsp;</td><td>&nbsp;%s Mb&nbsp;</td><td>&nbsp;(%s kb)</td></tr>\n", trim($name[$i]), $mb[$i], $kb[$i]);
    }
    $out .= "</table>\n";
    echo $out;
}

// parse PSFILES output
function parse_pstat_output($in) {
    preg_match('/([0-9a-f]{4})\s+([0-9a-f]{4})\s+([0-9a-f]{2})\s+(\S+)(.*)Thread.*Semaphores(.*)/ism', $in, $matches);
    list($match, $pid, $ppid, $sid, $process, $dlls, $threads) = $matches;
    $tmpl = "<pre>\n".
            "Process:  %s\n".
            "PID:      %d\n".
            "PPID:     %d\n".
            "Session:  0x%s\n".
            "</pre>\n";
    $out = sprintf($tmpl, $process, hexdec($pid), hexdec($ppid), $sid);
    preg_match_all('/\s+(\S.*)/m', $dlls, $matches);
    list($match, $dlls) = $matches;
    $out .= "<table border=0 cellpadding=0 cellspacing=0>\n";
    $out .= '<tr class="tr3"><th><span class="span1">Run-time link libraries</span></th><th>&nbsp;<span class="span1">Shared memory names</span></th></tr>'."\n";
    foreach ($dlls as $dll) {
        list($dll, $memname) = preg_split('/\s+/', $dll);
        $out .= "<tr class=\"tr2\"><td>$dll</td><td>&nbsp;$memname</td></tr>";
    }
    $out .= "\n</table>\n";
    $out .= "<br>Threads\n";
    preg_match_all('/\s+(\S.*)/m', $threads, $matches);
    list($match, $threads) = $matches;
    $out .= "<table border=0 cellpadding=0 cellspacing=0>\n";
    $out .= '<tr class="tr1"><th><span class="span1">ID</span>&nbsp;</th><th><span class="span1">Priority</span>&nbsp;</th><th><span class="span1">State</span>&nbsp;</th><th><span class="span1">Block ID</span>&nbsp;</th><th><span class="span1">Owned Semaphores</span></th></tr>'."\n";
    $tmpl = '<tr><td>%d&nbsp;</td>'.                // thread id
            '<td title="%s">%s&nbsp;</td>'.         // prio
            '<td>%s&nbsp;</td>'.                    // state
            '<td>%s&nbsp;</td>'.                    // block
            "<td>%s&nbsp;</td></tr>\n";             // sem
    foreach ($threads as $thread) {
        list($tid, $prio, $state, $block, $sem) = preg_split('/\s+/', $thread);
        $out .= sprintf($tmpl, $tid, say_prio($prio), $prio, $state, $block, $sem);
    }
    $out .= "\n</table>";
    return $out;
}

// parse PSFILES output
function parse_psfiles_output($in) {
    preg_match_all('/([0-9a-f]{4}) ([0-9a-f]{4}) ([0-9a-f]{4})([0-9a-f]{4}| no )\s*([0-9a-f]{8}|)\s*([0-9a-f]{8}|)\s*([0-9a-f]{8}|)\s*([0-9a-f]{4}|)\s*([0-9a-f]{4}|)\s*(.*)/m', $in, $matches);
    // pid  Hdl  SFN  refs flags    mode     size     hvpb attr name
    list($match, $pid, $Hdl, $SFN, $refs, $flags, $mode, $size, $hvpb, $attr, $name) = $matches;
    $out = "<table border=0 cellpadding=0 cellspacing=0>\n";
    $out .= '<tr class="tr1"><th>Hdl&nbsp;</th><th title="system file handle">SFN&nbsp;</th><th>refs&nbsp;</th><th>flags&nbsp;</th><th align="center">mode&nbsp;</th><th>size&nbsp;</th><th title="volume parameter block handle">hvpb&nbsp;</th><th align="center">attr&nbsp;</th><th align="left">name&nbsp;</th></tr>'."\n";
    $tmpl = '<tr valign="top">'.
    '<td title=" 0x%s ">&nbsp;%d&nbsp;</td>'.               // Hdl
    '<td>&nbsp;%s&nbsp;</td>'.                              // SFN
    '<td title=" 0x%s ">&nbsp;%d&nbsp;</td>'.               // refs
    '<td>&nbsp;%s&nbsp;</td>'.                              // flags
    '<td align="left" title=" 0x%s ">%s</td>'.              // mode
    '<td title=" 0x%s ">&nbsp;%s&nbsp;</td>'.               // size
    '<td>&nbsp;%s&nbsp;</td>'.                              // hvpb
    '<td align="left" title=" 0x%s ">%s</td>'.              // attr
    '<td align="left">%s</td>'.                             // name
    "</tr>\n";
    $n = sizeof($match);
    for ($i=0;$i<$n;$i++) {
        $out .= sprintf($tmpl,
                $Hdl[$i], hexdec($Hdl[$i]),
                $SFN[$i],
                $refs[$i], hexdec($refs[$i]),
                $flags[$i],
                $mode[$i], say_mode($mode[$i]),
                $size[$i], nice_decimal(hexdec($size[$i])),
                $hvpb[$i],
                $attr[$i], say_attr($attr[$i]),
                trim($name[$i]));
    }
    $out .= '</table>';
    return $out;
}

// sorting functions
function sort_by_pid($a, $b) {
    return (intval($a['pid']) < intval($b['pid'])) ? -1 : 1;
}

function sort_by_ppid($a, $b) {
    if (intval($a['ppid']) == intval($b['ppid'])) {
        return (intval($a['pid']) < intval($b['pid'])) ? -1 : 1;
    }
    return (intval($a['ppid']) < intval($b['ppid'])) ? -1 : 1;
}

function sort_by_sess($a, $b) {
    if ($a['sess1'] == $b['sess1']) {
        if ($a['sess2'] == $b['sess2']) {
            return (intval($a['pid']) < intval($b['pid'])) ? -1 : 1;
        }
        return ($a['sess2'] < $b['sess2']) ? -1 : 1;
    }
    return ($a['sess1'] < $b['sess1']) ? -1 : 1;
}

function sort_by_thr($a, $b) {
    if (intval($a['thr']) == intval($b['thr'])) {
        return (intval($a['pid']) < intval($b['pid'])) ? -1 : 1;
    }
    return (intval($a['thr']) > intval($b['thr'])) ? -1 : 1;
}

function sort_by_prio($a, $b) {
    if ($a['prio'] == $b['prio']) {
        return (intval($a['pid']) < intval($b['pid'])) ? -1 : 1;
    }
    return ($a['prio'] > $b['prio']) ? -1 : 1;
}

function sort_by_privmem($a, $b) {
    GLOBAL $mem;
    $mema = (float)$mem[$a['pid']]['privmem'];
    $memb = (float)$mem[$b['pid']]['privmem'];
    if ($mema == $memb) {
        return ($a['pid'] < $b['pid']) ? -1 : 1;
    }
    return ($mema > $memb) ? -1 : 1;
}

function sort_by_shmem($a, $b) {
    GLOBAL $mem;
    $mema = (float)$mem[$a['pid']]['shmem'];
    $memb = (float)$mem[$b['pid']]['shmem'];
    if ($mema == $memb) {
        return ($a['pid'] < $b['pid']) ? -1 : 1;
    }
    return ($mema > $memb) ? -1 : 1;
}

function sort_by_cpu($a, $b) {
    preg_match('/(\d+):(\d{2}):(\d{2})\.(\d{2})/', $a['cpu'], $m);
    list($match, $h, $m, $s, $th) = $m; $a1 = 60*60*$h + 60*$m + $s + $th/100;
    preg_match('/(\d+):(\d+):(\d+)\.(\d+)/', $b['cpu'], $m);
    list($match, $h, $m, $s, $th) = $m; $b1 = 60*60*$h + 60*$m + $s + $th/100;
    if ($a1 == $b1) {
        return (intval($a['pid']) < intval($b['pid'])) ? -1 : 1;
    }
    return ($a1 > $b1) ? -1 : 1;
}

function sort_by_name($a, $b) {
    if (trim($a['name']) == trim($b['name'])) {
        return (intval($a['pid']) < intval($b['pid'])) ? -1 : 1;
    }
    return (trim($a['name']) < trim($b['name'])) ? -1 : 1;
}

// redirection
function my_redirect($url, $code = 302) {
    if ($code == 303) {
        preg_match('/^HTTP\/(\d)\.(\d)/', $_SERVER['SERVER_PROTOCOL'], $m);
        if (intval($m[1])*10+intval($m[2]) < 11) { $code = 302; }
    }
    if ($code == 303) {
        Header($_SERVER['SERVER_PROTOCOL'].' 303 See Other');
    } else {
        Header($_SERVER['SERVER_PROTOCOL'].' 302 Found');
    }
    if (substr($url, 0, 1) == '/') {
        $url = 'http://'.$_SERVER['HTTP_HOST'].$url;
    } elseif (!strpos($url, '://')) {
        preg_match('/(.+?)[^\/]+$/', $_SERVER['REQUEST_URI'], $m);
        $url = 'http://'.$_SERVER['HTTP_HOST'].$m[1].$url;
    }
    Header('Location: '.$url);
?>
<html><head><title>Oops!</title></head><body><br><br>
    HTTP redirect (status code: <?=$code?>).<br>
  <a href="<?=$url?>"> </a>.
<br><hr size=1 width="50%" noshade align="left"><br>
Your browser does not understand HTTP redirect (status code: <?=$code?>).<br>
Follow <a href="<?=$url?>">this link</a>.
</body></html>
<?
}

// return fsOpenMode
function say_mode($str) {
    GLOBAL $modes1, $modes_10_8, $mask_10_8, $modes2, $modes_2_0, $mask_2_0;
    if (!strlen($str)) { return '&nbsp;- - -'; }
    $mode = hexdec($str);
    $out = '';
    foreach ($modes1 as $bit => $name) {
        if (($mode & $bit) == $bit) {
            $out .= '&nbsp;'.$name.'&nbsp;<br>';
        }
    }
    foreach ($modes_10_8 as $bit => $name) {
        if ((($mode & $mask_10_8) & $bit) == $bit) {
            $out .= '&nbsp;'.$name.'&nbsp;<br>';
            break;
        }
    }
    foreach ($modes2 as $bit => $name) {
        if (($mode & $bit) == $bit) {
            $out .= '&nbsp;'.$name.'&nbsp;<br>';
        }
    }
    foreach ($modes_2_0 as $bit => $name) {
        if ((($mode & $mask_2_0) & $bit) == $bit) {
            $out .= '&nbsp;'.$name.'&nbsp;';
            break;
        }
    }
    return $out;
}

// return ulAttribute
function say_attr($str) {
    GLOBAL $attrs;
    if (!strlen($str)) { return '&nbsp;- - -'; }
    $attr = hexdec($str);
    if (!$attr) {
        $out = '&nbsp;FILE_NORMAL&nbsp;';
    } else {
	    $out = '';
        foreach ($attrs as $bit => $name) {
            if (($attr & $bit) == $bit) {
                $out .= '&nbsp;'.$name.'&nbsp;<br>';
            }
        }
        $out = substr($out, 0, -4);
    }
    return $out;
}

// 02xx -> regular+xx
function say_prio($str) {
    GLOBAL $priorities;
    return $priorities[(intval($str[1]))].'+'.substr($str, -2);
}

// 1234567 -> 1,234,567
function nice_decimal($a, $separator = ',') {
    $a = strval($a);
    $out = '';
    for($i=strlen($a);$i>3;$i-=3) {
        $out = $separator.substr($a, $i-3, 3).$out;
    }
    return substr($a, 0, $i).$out;
}

// Dmitry Ban, ban@ram.ru

?>
